#!/bin/bash

gp_test "skip" "empty" "empty"
gp_test "skip" "list" "list"
gp_test "skip" "all-features" "all-features"

gp_test "try-fail" "empty" "empty"
gp_test "try-fail" "list" "list"
gp_test "try-fail" "all-features" "all-features"
gp_test "break-break" "empty" "empty-blue"

gp_test "div-zero" "empty" "div-zero"
gp_test "dfs-back" "dfs-back" "dfs-back"

gp_test "bridge" "bridge-1" "bridged"
gp_test "bridge" "bridge-2" "bridge-fail"
gp_test "bridge" "bridge-3" "bridge-fail"

gp_test "intro" "empty" "intro"
gp_test "intro-green" "empty" "intro-green"
gp_test "intro-root" "empty" "intro-root"
gp_test "intro-red-root" "empty" "intro-red-root"

gp_test "match-non-root" "discrete-1" "discrete-1"
gp_test "match-non-root" "gen-1" "gen-1"
gp_test "match-root" "discrete-1" "rule-fail"
gp_test "match-root" "gen-1" "gen-1"

gp_test "match-root-edge-root" "no-root-pair" "rule-fail"
gp_test "match-root-edge-root" "single-root-pair" "rule-fail"
gp_test "match-root-edge-root" "double-root-pair" "double-root-pair"
gp_test "match-root-edge-non-root" "no-root-pair" "rule-fail"
gp_test "match-root-edge-non-root" "single-root-pair" "single-root-pair"
gp_test "match-root-edge-non-root" "double-root-pair" "double-root-pair"

gp_test "add-one" "discrete-6" "discrete-7"
gp_test "add-if-label" "discrete-6" "add-fail"
gp_test "add-if-edge" "discrete-6" "add-fail"
gp_test "add-if-edge" "discrete-6-loop" "discrete-7-loop"

gp_test "add-edge" "double-discrete" "proper-edge-1" "proper-edge-2"
gp_test "add-loop" "discrete-1" "trivial-loop"
gp_test "add-loops" "discrete-1" "trivial-loops"
gp_test "del-loops" "single-loops" "tree-0"

gp_test "match-node-any" "discrete-6" "rule-fail"
gp_test "match-node-any" "discrete-6-grey" "discrete-6-grey"
gp_test "match-node-any" "discrete-6-green" "discrete-6-green"
gp_test "match-edge-any" "discrete-6-loop" "rule-fail"
gp_test "match-edge-any" "discrete-6-loop-dashed" "discrete-6-loop-dashed"
gp_test "match-edge-any" "discrete-6-loop-red" "discrete-6-loop-red"

gp_test "relabel-any" "red-root" "red-root"
gp_test "invalid-any-no-lhs" "empty" "invalid-any-no-lhs"
gp_test "invalid-any-no-interface" "empty" "invalid-any-no-interface"
gp_test "invalid-interface-lhs" "empty" "invalid-interface-lhs"
gp_test "invalid-interface-rhs" "empty" "invalid-interface-rhs"

gp_test "where-no-indeg" "triangle" "rule-fail"
gp_test "where-no-indeg" "discrete-1" "discrete-1"
gp_test "where-no-outdeg" "triangle" "rule-fail"
gp_test "where-no-outdeg" "discrete-1" "discrete-1"

gp_test "where-indeg-gt" "random-list" "rule-fail"
gp_test "where-indeg-gt" "star-in" "star-in"
gp_test "where-indeg-gt" "star-out" "rule-fail"
gp_test "where-outdeg-gt" "random-list" "rule-fail"
gp_test "where-outdeg-gt" "star-in" "rule-fail"
gp_test "where-outdeg-gt" "star-out" "star-out"

gp_test "where-edge" "discrete-1" "rule-fail"
gp_test "where-edge" "discrete-7-loop" "discrete-7-loop"
gp_test "where-not-edge" "discrete-1" "discrete-1"
gp_test "where-not-edge" "discrete-7-loop" "rule-fail"

gp_test "where-edge-var" "discrete-1" "rule-fail"
gp_test "where-edge-var" "discrete-7-loop" "rule-fail"
gp_test "where-edge-var" "discrete-7-loop-7" "discrete-7-loop-7"

gp_test "where-edge-empty-any" "random-list" "rule-fail"
gp_test "where-edge-empty-any" "grey-edged-list-1" "grey-edged-list-1"
gp_test "where-edge-empty-any" "grey-edged-list-2" "rule-fail"
gp_test "where-edge-empty-any" "green-edged-list" "green-edged-list"
gp_test "where-edge-empty-any" "unmarked-edge-list" "rule-fail"
gp_test "where-edge-empty-any" "int-square" "rule-fail"

gp_test "where-edge-empty-grey" "random-list" "rule-fail"
gp_test "where-edge-empty-grey" "grey-edged-list-1" "grey-edged-list-1"
gp_test "where-edge-empty-grey" "grey-edged-list-2" "rule-fail"
gp_test "where-edge-empty-grey" "green-edged-list" "rule-fail"
gp_test "where-edge-empty-grey" "unmarked-edge-list" "rule-fail"
gp_test "where-edge-empty-grey" "int-square" "rule-fail"

gp_test "where-edge-empty-green" "random-list" "rule-fail"
gp_test "where-edge-empty-green" "grey-edged-list-1" "rule-fail"
gp_test "where-edge-empty-green" "grey-edged-list-2" "rule-fail"
gp_test "where-edge-empty-green" "green-edged-list" "green-edged-list"
gp_test "where-edge-empty-green" "unmarked-edge-list" "rule-fail"
gp_test "where-edge-empty-green" "int-square" "rule-fail"

gp_test "where-edge-empty-unmarked" "random-list" "random-list"
gp_test "where-edge-empty-unmarked" "grey-edged-list-1" "rule-fail"
gp_test "where-edge-empty-unmarked" "grey-edged-list-2" "rule-fail"
gp_test "where-edge-empty-unmarked" "green-edged-list" "rule-fail"
gp_test "where-edge-empty-unmarked" "unmarked-edge-list" "rule-fail"
gp_test "where-edge-empty-unmarked" "int-square" "rule-fail"

gp_test "where-edge-string-any" "random-list" "rule-fail"
gp_test "where-edge-string-any" "grey-edged-list-1" "rule-fail"
gp_test "where-edge-string-any" "grey-edged-list-2" "grey-edged-list-2"
gp_test "where-edge-string-any" "green-edged-list" "rule-fail"
gp_test "where-edge-string-any" "unmarked-edge-list" "rule-fail"
gp_test "where-edge-string-any" "int-square" "rule-fail"

gp_test "where-edge-string-grey" "random-list" "rule-fail"
gp_test "where-edge-string-grey" "grey-edged-list-1" "rule-fail"
gp_test "where-edge-string-grey" "grey-edged-list-2" "grey-edged-list-2"
gp_test "where-edge-string-grey" "green-edged-list" "rule-fail"
gp_test "where-edge-string-grey" "unmarked-edge-list" "rule-fail"
gp_test "where-edge-string-grey" "int-square" "rule-fail"

gp_test "where-edge-string-unmarked" "random-list" "rule-fail"
gp_test "where-edge-string-unmarked" "grey-edged-list-1" "rule-fail"
gp_test "where-edge-string-unmarked" "grey-edged-list-2" "rule-fail"
gp_test "where-edge-string-unmarked" "green-edged-list" "rule-fail"
gp_test "where-edge-string-unmarked" "unmarked-edge-list" "unmarked-edge-list"
gp_test "where-edge-string-unmarked" "int-square" "rule-fail"

gp_test "where-edges-neg-conjunct" "discrete-1" "rule-fail"
gp_test "where-edges-neg-conjunct" "unmarked-2-cycle" "rule-fail"
gp_test "where-edges-neg-conjunct" "unmarked-2-list" "unmarked-2-list"
gp_test "where-edges-neg-conjunct" "grey-2-list" "rule-fail"

gp_test "unmark-check-1" "empty" "empty"
gp_test "unmark-check-1" "discrete-1-grey" "discrete-1"
gp_test "unmark-check-1" "grey-unmarked" "fail"
gp_test "unmark-check-2" "empty" "empty"
gp_test "unmark-check-2" "discrete-1-grey" "discrete-1-grey"
gp_test "unmark-check-2" "grey-unmarked" "fail"

gp_test "list-len" "list-label-discrete" "discrete-7"
gp_test "edge-sum" "nat-loops" "discrete-6-root"
gp_test "edge-sum" "int-loops" "gen-1"

gp_test "extract-head" "discrete-empty" "rule-fail"
gp_test "extract-head" "discrete-1" "singleton-1"
gp_test "extract-head" "list-label-discrete" "extracted-head"
